<app-spinner class="center-spinner" *ngIf="!isPageLoaded"></app-spinner>
<!-- <app-spinner class="center-line-spinner" diameter="30"></app-spinner> -->
<!-- <app-spinner class="spinner-bordered"></app-spinner> -->
<!-- <span class="spinner-bordered"><app-spinner></app-spinner></span> -->
<!-- <span class="spinner-bordered spinner-bordered-center-line"><app-spinner></app-spinner></span> -->
<div xhidden>
<button class="mat-flat-button btn-primary"
        mat-flat-button
        (click)="openDialog('alert', dialogMsg)"
        color="primary">Alert</button>
<button class="mat-flat-button btn-primary"
        mat-flat-button
        (click)="openDialog('alert', dialogMsgComplex)"
        color="primary">Alert Complex</button>
<button class="mat-flat-button btn-primary"
        mat-flat-button
        (click)="openDialog('confirm', dialogMsg)"
        color="primary">Confirm</button>
<button class="mat-flat-button btn-primary"
        mat-flat-button
        (click)="openDialog('delete', dialogMsg)"
        color="warn">Delete</button>
<button class="mat-flat-button btn-primary"
        mat-flat-button
        (click)="openDialog('spin', 'Custom message...')"
        color="primary">Custom Spin Message</button>
<button class="mat-flat-button btn-primary"
        mat-flat-button
        (click)="openDialog('spin')"
        color="primary">Default Spin</button>
<button class="mat-flat-button btn-primary"
        (click)="openDialog('spin', '')"
        color="primary">Empty text Spin</button>

<button class="mat-stroked-button mat-primary"
        (click)="openToast('success')">Toast - Suceess</button>
<button class="mat-stroked-button mat-accent"
        (click)="openToast('warning')">Warning</button>
<button class="mat-stroked-button mat-warn"
        (click)="openToast('error')">Error</button>
<button class="mat-stroked-button"
        (click)="openToast('info')">Info</button>
<button class="mat-stroked-button"
        (click)="openToast()">Notify</button>

<div class="form-action-btn-bar">
  <button class="mat-flat-button btn-primary"
          [disabled]="isSaving"
          (click)="save()"
          color="primary">Save
          <app-spinner button class="inline-spinner" *ngIf="isSaving"></app-spinner>
        </button>
  <button class="mat-flat-button"
          (click)="cancel()"
          color="accent">Cancel</button>
</div>
</div>
<mat-table [dataSource]="dataSource" matSort appFilter [matSortDisableClear]="true" class="app-table-grid">

  <!-- Status Column -->
  <ng-container matColumnDef="status">
    <mat-header-cell *matHeaderCellDef>
      <span mat-sort-header>Status</span>
      <app-filter></app-filter>
    </mat-header-cell>
    <mat-cell *matCellDef="let element">
      <!-- <button mat-mini-fab [ngClass]="statusClass[element.status]"></button> -->
      <app-status-indicator status="{{element.status}}" type="project"></app-status-indicator>
    </mat-cell>
  </ng-container>

  <!-- Name Column -->
  <ng-container matColumnDef="name">
        <mat-header-cell *matHeaderCellDef>
            <app-filter></app-filter>
            <span mat-sort-header>Project Name</span>
    </mat-header-cell>
    <mat-cell *matCellDef="let element"> {{element.name}} </mat-cell>
  </ng-container>

  <!-- Edit Column -->
  <ng-container matColumnDef="button_action">
    <mat-header-cell *matHeaderCellDef> </mat-header-cell>
    <mat-cell *matCellDef="let element"> 
        <!-- put below in btn-bar to have more margin(5px) -->
      <!-- <div class="btn-bar"> -->
        <button mat-flat-button class="btn-round btn-light" (click)="openProjectEditModal(element._id, element.name)">Edit</button>
        <button mat-flat-button color="primary" class="btn-round">Launch</button>
        <a [routerLink]="['/phases', element._id]" [queryParams]="{projectName: element.name}">
          <button mat-flat-button class="btn-round btn-success">End</button>
        </a>
      <!-- </div> -->
    </mat-cell>
  </ng-container>
  
  <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
  <mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>
</mat-table>
<div class="mat-row mat-row-table-empty" role="row" *ngIf="!dataSource.filteredData.length  && isPageLoaded">
    <div class="mat-cell generic-empty-message-text" role="gridcell"></div>
</div>


<!-- <mat-table #table
           [dataSource]="dataSource"
           class="app-table-grid"> -->

  <!--- Note that these columns can be defined in any order.
            The actual rendered columns are set as a property on the row definition" -->

  <!-- Checkbox Column -->
  <!-- <ng-container matColumnDef="select">
    <mat-header-cell *matHeaderCellDef>
      <mat-checkbox (change)="$event ? masterToggle() : null"
                    [checked]="selection.hasValue() && isAllSelected()"
                    [indeterminate]="selection.hasValue() && !isAllSelected()">
      </mat-checkbox>
    </mat-header-cell>
    <mat-cell *matCellDef="let row">
      <mat-checkbox (click)="$event.stopPropagation()"
                    (change)="$event ? selection.toggle(row) : null"
                    [checked]="selection.isSelected(row)">
      </mat-checkbox>
    </mat-cell>
  </ng-container> -->

  <!-- Name Column -->
  <!-- <ng-container matColumnDef="name">
    <mat-header-cell *matHeaderCellDef> Name </mat-header-cell>
    <mat-cell *matCellDef="let element"> {{element.name}} </mat-cell>
  </ng-container> -->

  <!-- Symbol Column -->
  <!-- <ng-container matColumnDef="symbol">
    <mat-header-cell *matHeaderCellDef> Action </mat-header-cell>
    <mat-cell *matCellDef="let element">
      <a routerLink="/phases/{{element.position}}">
        <button class="mat-flat-button btn-primary"
                mat-flat-button
                color="primary">Phases</button>
      </a>
    </mat-cell>
  </ng-container>

  <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row> -->
  <!-- row click selection commented out for now -->
  <!-- <mat-row *matRowDef="let row; columns: displayedColumns;" (click)="$event ? selection.toggle(row) || $event.stopPropagation() : null" -->
  <!-- <mat-row *matRowDef="let row; columns: displayedColumns;"
           [class.selected]="selection.isSelected(row)"></mat-row>
</mat-table> -->
<!-- </div>
</div> -->